/*
 *	The Kibitz - Debugging Customization
 *
 *	(c) 2005 Tomas Valla <tom@ucw.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU Lesser General Public License. See COPYING for details.
 */

#ifndef _KIBITZ_CUSTOM_H
#define _KIBITZ_CUSTOM_H

#define CUSTOM_INDEX_TYPE 'D'			/* A byte identifying our flavor of index format */
#define CUSTOM_INDEX_VERSION 1			/* Remember to increase after each change of custom parts of the index */

/* Data we remember in the index for each phrase */

struct phrase_attrs {
	u32 results;		/* Number of results the phrase returns */
};


struct fastbuf;
struct mempool;

/* Read input fastbuf, load one phrase, allocated in mp and return the pointer */
struct phrase *custom_get_phrase(struct fastbuf *fb, struct mempool *mp);

/* Scan one phrase and return all its words by calling wordref_add(wstart, wlen) */
void custom_get_words(struct phrase *p);

/* Auxiliary routine to printf attributes to fb */
void dump_custom_struct_phrase_attrs(struct fastbuf *fb, struct phrase_attrs *at);

#define CUSTOM_HTTP_RESULT_HEADER(c) "var kbd = new Array (\r\n"
#define CUSTOM_HTTP_RESULT_FOOTER(c) "); kb.disp(kbd);\r\n"

/* Return string with one formatted result line */
#define CUSTOM_HTTP_RESULT_LINE(c,r) stk_printf("['%s','%d']", (r)->phrase.text, (r)->phrase.attrs.results)

/* The lines delimiter */
#define CUSTOM_HTTP_RESULT_LINE_DELIM(c) ",\r\n"

#endif
